/*
 * Copyright (C) . ॢ, 1999
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long Var, Count;

void ResourceGet();
void ResourceReturn();
void Work();

struct SafeResource {
       SafeResource()  { ResourceGet(); }
       ~SafeResource() { ResourceReturn(); }
};

void f1()
{
 ResourceGet();
 try {
     Work();
 }
 catch (...) {
       ResourceReturn();
       throw;
 }
 ResourceReturn();
}

void f2()
{
 SafeResource sr;
 Work();
}

int main(int argc,char** argv)
{
 if (argc>1) Count=atol(argv[1]);

 clock_t c1,c2;

 {
  c1=clock();

  for (long i=0; i<Count; i++)
      for (long j=0; j<1000000; j++)
          f1();

  c2=clock();
  printf("f1(): %ld mln calls per %.1f sec\n",Count,double(c2-c1)/CLK_TCK);
 }
 {
  c1=clock();

  for (long i=0; i<Count; i++)
      for (long j=0; j<1000000; j++)
          f2();

  c2=clock();
  printf("f2(): %ld mln calls per %.1f sec\n",Count,double(c2-c1)/CLK_TCK);
 }
}

void ResourceGet()     { Var++; }

void ResourceReturn()  { Var--; }

void Work() { Var+=2; }
