#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <list>

struct List {  // 吝 ᯨ᮪
       struct Data {
              int val;
              Data* next;

              Data(int v, Data* n=0) : val(v), next(n) {}
       };

       Data *head, *tail;

       List() { head=tail=0; }
       ~List() {
            for (Data *ptr=head, *n; ptr; ptr=n) {  // 㤠塞  
                n=ptr->next;
                delete ptr;
            }
       }

       void push_back(int v) {  // 塞 
         if (!head) head=tail=new Data(v);
         else tail=tail->next=new Data(v);
       }
};

long Count, Var;

void f1()
{
 List lst;
 for (int i=0; i<1000; i++)
     lst.push_back(i);

 for (List::Data* ptr=lst.head; ptr; ptr=ptr->next)
     Var+=ptr->val;
}

void f2()
{
 std::list<int> lst;
 for (int i=0; i<1000; i++)
     lst.push_back(i);

 for (std::list<int>::const_iterator ci=lst.begin(); ci!=lst.end(); ++ci)
     Var+=*ci;
}

int main(int argc,char** argv)
{
 if (argc>1) Count=atol(argv[1]);

 clock_t c1,c2;
 {
  c1=clock();

  for (long i=0; i<Count; i++)
      for (long j=0; j<1000; j++)
          f1();

  c2=clock();
  printf("f1(): %ld ths calls per %.1f sec\n",Count,double(c2-c1)/CLK_TCK);
 }
 {
  c1=clock();

  for (long i=0; i<Count; i++)
      for (long j=0; j<1000; j++)
          f2();

  c2=clock();
  printf("f2(): %ld ths calls per %.1f sec\n",Count,double(c2-c1)/CLK_TCK);
 }
}
