/*
 * Copyright (C) . ॢ, 1999
 *
 */

#include <iostream.h>
#include <ctype.h>

class c_formBase {  //   権
 private:
      const char* form;   // ଠ
      int   arg1, arg2;   // 㬥 ਭ/筮
      long        flags;  // ࠭塞 䫠
      int         width;  // ਭ
      int         prec;   // 筮
      char        fill;   // ᨬ-⥫
      long        myfl;   // ⠭ 䫠
 protected:
      //   ࠧ஬ ଠ
      // ଠ: [-|0] [᫮|*] [.[᫮|*]] [e|f|g|o|x]
      c_formBase( const char* form_,
                  const int arg1_,
                  const int arg2_
                )
      : form(form_), arg1(arg1_), arg2(arg2_) {
        const char* iptr=form;  // ⥪騩 ᨬ ப ଠ

        myfl=0;
        fill=0;
        if (*iptr=='-') {  // ࠢ 
           myfl|=ios::left;
           iptr++;
        }
        else if (*iptr=='0') {  // 塞 '0' ⮫쪮 ᫨ !left
                fill='0';
                iptr++;
             }

        width=0;
        if (*iptr=='*') {  // ⠥ ਭ, ᫨ 
           width=arg1;
           iptr++;

           arg1=arg2;  // ᤢ 㬥 
        }
        else if (isdigit(*iptr)) width=getval(iptr);

        prec=0;
        if (*iptr=='.') {  //  筮
           if (*++iptr=='*') {
              prec=arg1;
              iptr++;
           }
           else if (isdigit(*iptr)) prec=getval(iptr);
        }

        switch (*iptr++) {
               case   0: return;  //  ப ଠ
               case 'e': myfl|=ios::scientific; break;
               case 'f': myfl|=ios::fixed;      break;
               case 'g':                        break;
               case 'o': myfl|=ios::oct;        break;
               case 'x': myfl|=ios::hex;        break;
        }
      }

      static int getval(const char*& iptr) {  // ⥭ ᫠
             int ret=0;
             do ret=ret*10+ *iptr -'0';
                while (isdigit(*++iptr));

             return ret;
      }

      void prologue(ostream& os) {  // ன
           flags=os.flags();
           // 頥 floatfield  ⠭ ᢮ 䫠
           os.flags((flags & ~ios::floatfield) | myfl);

           if (width) os.width(width);
           if (fill)  fill=os.fill(fill);
           if (prec)  prec=os.precision(prec);
      }

      void epilogue(ostream& os) {  // ⠭
           os.flags(flags);

           if (fill) os.fill(fill);
           if (prec) os.precision(prec);
      }
};

template <class T>
class c_formClass : private c_formBase {  // -蠡  뢮 ⨯ T
      T val;  // 뢮 祭
 public:
      c_formClass( T val_,
                   const char* form,
                   const int arg1,
                   const int arg2
                 )
      : c_formBase(form,arg1,arg2), val(val_) { }

      //  뢮
      friend ostream& operator<<(ostream& os, const c_formClass<T>& cf_) {
             c_formClass<T>& cf=(c_formClass<T>&) cf_;

             cf.prologue(os);
             os<<cf.val;
             cf.epilogue(os);

             return os;
      }
};

template <class T>  // 㭪-魨 ( 㬥)
inline c_formClass<T> c_form(T val, char* form, int arg1, int arg2)
{ return c_formClass<T>(val,form,arg1,arg2); }

template <class T>  // 㭪-魨 ( 㬥)
inline c_formClass<T> c_form(T val, char* form, int arg1)
{ return c_formClass<T>(val,form,arg1,0); }

template <class T>  // 㭪-魨 ( 㬥⮢)
inline c_formClass<T> c_form(T val, char* form)
{ return c_formClass<T>(val,form,0,0); }

int main()
{
 int day= 31,
     mon= 1,
     year=1974;

 cout<<c_form(day,"02")<<'.'<<c_form(mon,"02")<<'.'<<year<<'\n';
}
